<?xml version="1.0" encoding="iso-8859-1"?>

<!-- 
  Please see the license.html file included with this distribution for 
  attribution and copyright information.
-->

<root>
    <!-- menu button window class-->
    <windowclass name="menulist_window">
        <noclose />
        <script>
      function onInit()
            Debug.console('desktop_classes_adnd: onInit1')

        setSize(245,35);
        MenuManager.registerWindowMenu(self);
        onLockStateChanged();
      end
      function onLockStateChanged()
      Debug.console('desktop_classes_adnd: onLockStateChanged1')
        local bLocked = getLockState();
        moveicon.setVisible(not bLocked);
      end
 
       --[[ This will close other menus if user opens a menu drop down and doesnt
           mouse over it but slides over other menu button sThisControlName is
           menutype field, 'menus' or 'records'
      ]]
        function hideOtherButtonMenus(sThisControlName)
        Debug.console('desktop_classes_adnd: hideOtherButtonMenus')
          local aControls = getControls();
          if #aControls > 0 then
            for i=1 , #aControls do
              local sControlName = aControls[i].getName();
              local sControlType = type(aControls[i]);
              if sControlName ~= sThisControlName and sControlType == 'buttoncontrol' and sControlName ~= 'moveicon' then
                if aControls[i].windowDropDown and not aControls[i].windowDropDown.isMinimized() then
                  aControls[i].windowDropDown.minimize();
                end
              end
            end
          end
        end   
      
        </script>
        <sheetdata>

            <buttoncontrol name="menus">
                <frame name="menu_buttonup_light" offset="2,2,2,2" />
                <stateframe>
                    <pressed name="menu_buttondown" offset="2,2,2,2" nobaseframe="true" />
                </stateframe>
                <script file="desktop/scripts/menubutton.lua" />
                <menutype>menus</menutype>
                <anchored height="33" width="75">
                    <top parent="" offset="-3" />
                    <left parent="" anchor="left" offset="-3" />
                </anchored>
                <font>bold-light</font>
                <center />
            </buttoncontrol>

            <buttoncontrol name="records">
                <frame name="menu_buttonup_light" offset="2,2,2,2" />
                <stateframe>
                    <pressed name="menu_buttondown" offset="2,2,2,2" nobaseframe="true" />
                </stateframe>
                <script file="desktop/scripts/menubutton.lua" />
                <menutype>records</menutype>
                <anchored height="33" width="75">
                    <top parent="" offset="-3" />
                    <left parent="menus" anchor="right" offset="0" />
                </anchored>
                <font>bold-light</font>
                <center />
            </buttoncontrol>

            <buttoncontrol name="refmanuals">
                <frame name="menu_buttonup_light" offset="2,2,2,2" />
                <stateframe>
                    <pressed name="menu_buttondown" offset="2,2,2,2" nobaseframe="true" />
                </stateframe>
                <script file="desktop/scripts/menubutton.lua" />
                <menutype>refmanuals</menutype>
                <anchored height="33" width="75">
                    <top parent="" offset="-3" />
                    <left parent="records" anchor="right" offset="0" />
                </anchored>
                <font>bold-light</font>
                <center />
            </buttoncontrol>

            <buttoncontrol name="moveicon">
                <anchored to="refmanuals" position="righthigh" offset="0,10" height="15" width="15" />
                <state icon="movearrows" pressed="movearrows" />
                <disabled />
            </buttoncontrol>

        </sheetdata>
    </windowclass>

    <!-- refmanuals dropdown window -->
    <windowclass name="refmanuals_dropwindow">
        <script file="desktop/scripts/menulist.lua" />
        <sizelimits>
            <minimum width="20" height="20" />
            <dynamic />
        </sizelimits>
        <nomove />
        <noclose />
        <minimize>blank_icon</minimize>
        <frame>darkbox_transparent</frame>
        <sheetdata>
            <menu_refmanuals_list name="refmanuals" />
            <scrollbar name="scroller">
                <anchored to="refmanuals" offset="-15" />
                <target>refmanuals</target>
            </scrollbar>
        </sheetdata>
    </windowclass>

    <!-- records dropdown window -->
    <windowclass name="records_dropwindow">
        <script file="desktop/scripts/menulist.lua" />
        <sizelimits>
            <minimum width="20" height="20" />
            <dynamic />
        </sizelimits>
        <nomove />
        <noclose />
        <minimize>blank_icon</minimize>
        <frame>darkbox_transparent</frame>
        <sheetdata>
            <menu_records_list name="records" />
            <scrollbar name="scroller">
                <anchored to="records" offset="-15" />
                <target>records</target>
            </scrollbar>
        </sheetdata>
    </windowclass>

    <!-- menus dropdown window -->
    <windowclass name="menus_dropwindow">
        <script file="desktop/scripts/menulist.lua" />
        <sizelimits>
            <minimum width="20" height="20" />
            <dynamic />
        </sizelimits>
        <nomove />
        <noclose />
        <minimize>blank_icon</minimize>
        <frame>darkbox_transparent</frame>
        <sheetdata>
            <menu_menus_list name="menus" />
            <scrollbar name="scroller">
                <anchored to="menus" offset="-15" />
                <target>menus</target>
            </scrollbar>
        </sheetdata>
    </windowclass>


    <!-- menu list record, contains a path and record+name=window or a record+name=Index -->
    <windowclass name="menu_record_item">
        <sheetdata>
            <hs name="path" />
            <hs name="record" />
            <hn name="insert" />
            <hs name="name" />
            <label name="record_name">
                <script>
          function onHover(bOver)
          Debug.console('desktop_classes_adnd: onHover')
            if bOver then
              window.setFrame("lightbox_transparent");
            else
              window.setFrame("");
            end
          end
          function onClickDown(button, x, y)
          Debug.console('desktop_classes_adnd: onClickDown')
            local sName = window.name.getValue();
            local sPath = window.path.getValue();
            local sRecord = window.record.getValue();
            local bInsert = window.insert.getValue() == 1;
            if (sPath and sPath ~= "" ) then
              if sPath ~= 'library' then
                Interface.openWindow(sRecord,sPath);
              else
                Interface.openWindow(sRecord,"");
              end
            elseif bInsert then
              Interface.openWindow(sRecord,sPath);
            else
              DesktopManager.toggleIndex(sRecord);
            end
              window.windowlist.window.minimizeMe();
            return true;
          end
          function onDragStart(button, x, y, draginfo)
          Debug.console('desktop_classes_adnd: onDragStart')
            local sPath = window.path.getValue();
            if (not sPath or sPath == "" ) then
              local sRecordType = window.record.getValue();
              draginfo.setType("shortcut");
              local sIcon = 'char_notes';
              draginfo.setIcon(sIcon);
              local sClass, sRecord = DesktopManager.getListLink(sRecordType);
              draginfo.setShortcutData(sClass, sRecord);
              draginfo.setDescription(Interface.getString("library_recordtype_label_" .. sRecord));
              return true;
            end
          end
                </script>
                <anchored height="20">
                    <top offset="0"/>
                    <left offset="4" />
                    <right offset="-4" />
                </anchored>
                <font>bold-light</font>
            </label>
        </sheetdata>
    </windowclass>


    <windowclass name="characterlist" merge="join">
        <noclose />
        <softclose />
        <script>
      function onLockStateChanged()
      Debug.console('desktop_classes_adnd: onLockStateChanged')
        moveicon.setVisible(not getLockState());
      end          
        </script>
        <sheetdata>
            <genericcontrol name="anchor" mergerule="replace">
                <bounds>5,30,20,90</bounds>
                <tooltip textres="moveanchor_portrait_tooltip" />
            </genericcontrol>
            <buttoncontrol name="moveicon">
                <anchored to="anchor" position="insidetopright" offset="0,25" height="15" width="15" />
                <state icon="movearrows" pressed="movearrows" />
                <disabled />
                <invisible />
            </buttoncontrol>
        </sheetdata>
    </windowclass>

    <windowclass name="dicetower" merge="join">
        <sizelimits>
            <minimum width="100" height="90" />
        </sizelimits>
        <sheetdata>
            <genericcontrol name="base">
                <bounds>0,0,100,90</bounds>
                <droptypes>
                    <type merge="add">attack</type>
                    <type merge="add">damage</type>
                    <type merge="add">heal</type>
                    <type merge="add">init</type>
                    <type merge="add">save</type>
                    <type merge="add">check</type>
                </droptypes>
            </genericcontrol>
        </sheetdata>
    </windowclass>

    <windowclass name="shortcuts" merge="join">
        <script>
      function onInit()
      Debug.console('desktop_classes_adnd: onInit')
        MenuManager.registerWindowSidebar(self);
        if super and super.onInit then
          super.onInit();
        end
      end
        </script>
    </windowclass>

    <template name="button_sidebar_gm">
        <button_sidebar_mode name="button_sidebar_gm">
            <anchored to="list">
                <top anchor="bottom" offset="55" />
                <right anchor="center" offset="-60" />
            </anchored>
            <mode>gm</mode>
        </button_sidebar_mode>
    </template>
    <template name="button_sidebar_play">
        <button_sidebar_mode name="button_sidebar_play">
            <anchored to="list">
                <top anchor="bottom" offset="55" />
                <left anchor="center" offset="-40" />
            </anchored>
            <mode>play</mode>
        </button_sidebar_mode>
    </template>
    <template name="button_sidebar_create">
        <button_sidebar_mode name="button_sidebar_create">
            <anchored to="list">
                <top anchor="bottom" offset="55" />
                <left anchor="center" offset="60" />
            </anchored>
            <state textres="sidebar_button_create" />
            <modelabel>sidebar_command_create</modelabel>
            <mode>create</mode>
        </button_sidebar_mode>
    </template>
    <template name="button_sidebar_all">
        <button_sidebar_mode name="button_sidebar_all">
            <anchored to="list">
                <top anchor="bottom" offset="25" />
                <right anchor="center" offset="-10" />
            </anchored>
            <mode>all</mode>
        </button_sidebar_mode>
    </template>

</root>
